//------------------------------------------------------------------------
// File name...............: KontoUdtogUdskrift.cpp
// Compiler................: MS-Visual C++ 5.00
// Library.................: Microsoft Foundation Classes
// Programmr..............: Bjrk Boye Busch
// Programmerings start....: 98-11-12
// Sidste opdatering.......: 98-11-12
// Revisions historie......:
// Beskrivelse.............:				   
//     Headerdefinition for KontoUdtogUdskrift-Klasse
//------------------------------------------------------------------------

#include "KontoUdtogUdskrift.h"


//------------------------------------------------------------------------
// Declaration af KontoUdtogUdskrift - funktionsklasse
//------------------------------------------------------------------------
CxKontoUdtogUdskrift::CxKontoUdtogUdskrift	(void)
:	SideNr(0), LinieNr(0), LinierPrSide(62)
{
	PrintInit();
	HovedStyring();
	PrintFinish();
}

CxKontoUdtogUdskrift::~CxKontoUdtogUdskrift	(void)
{}

void	CxKontoUdtogUdskrift::PrintInit		(void)
{
	pPrint = new (CxPrint);
	ReportHandler.AddReport(pPrint);
	pPrint->OpenPrint("Kundeoversigt",LinierPrSide);

	CTime T (CTime::GetCurrentTime());
	UdskriftsDato.Format("%02d-%02d-%04d",
						  T.GetDay(),T.GetMonth(),T.GetYear() 
						);
	UdskriftsTid.Format("%02d:%02d",
						 T.GetHour(),T.GetMinute()
						);
}

void	CxKontoUdtogUdskrift::PrintFinish	(void)
{
	pPrint->ClosePrint();
}
void	CxKontoUdtogUdskrift::HovedStyring	(void)
{
	FirstMainItem();
	while (MoreMainItems())
		BehandlMainItem();
}

void	CxKontoUdtogUdskrift::BehandlMainItem	(void)
{
	FirstSubItem();
	while (MoreSubItems())
		UdskrivSide();
	NextMainItem();
}

void	CxKontoUdtogUdskrift::UdskrivSide	(void)
{
	UdskrivHeader();
	UdskrivBody();
	UdskrivFoot();
}

void	CxKontoUdtogUdskrift::UdskrivHeader	(void)
{
	++SideNr;
	CString Text;
	Text.Format("%-64s Side %3ld","Kundeoversigt", SideNr);
	pPrint->PrintLine(Text);
	pPrint->PrintLine(CString('-',74);
	pPrint->PrintLine("");
	LinieNr = 3;
}
void	CxKontoUdtogUdskrift::UdskrivFoot	(void)
{
	CString Text;
	pPrint->PrintLine(CString('-',74);
	Text.Format("%8s%63s",UdskriftsDato, UdskriftsTid);
	pPrint->PrintLine(Text);
	LinieNr = LinieNr + 2;
}
void	CxKontoUdtogUdskrift::UdskrivBody	(void)
{
	UdskrivMainItem();

	long MaxBodyLine(LinierPrSide-2); 

	while (MoreSubItems() && (LinieNr < MaxBodyLine))
		BehandlSubItem();

	for (; (LinieNr < MaxBodyLine); ++LinieNr)
		pPrint->PrintLine("");
}

void	CxKontoUdtogUdskrift::UdskrivMainItem	(void)
{
	KundeKontoLink.QueryKontoNr(Konto.GetKontoNr());
	Kunde.QueryKundeNr(KundeKontoLink.GetKundeNr());
	PostDistrikt.QueryPostNr(Kunde.GetPostNr());

	CString Text;

	Text.Format("Kunde: %04ld %38s Konto:            %04ld",
				 Kunde.GetKundeNr(),"",Konto.GetKontoNr()	);
	pPrint->PrintLine(Text);

	Text.Format("%-50s Max.Kred:   %10.2f",
				 (Kunde.GetFornavn()+" "+Kunde.GetEfternavn()),
				 Konto.GetMaxKredit()	);
	pPrint->PrintLine(Text);

	Text.Format("%-50s Rente udl.: %10.2f",
				 Kunde.GetAdresse(), Konto.GetRenteSatsUdlaan()	);
	pPrint->PrintLine(Text);
	
	Text.Format("%4ld %-45s Rente indl.:%10.2f",
				 PostDistrikt.GetPostNr(), PostDistrikt.GetDistrikt(),
				 Konto.GetRenteSatsIndlaan()	);
	pPrint->PrintLine(Text);
	
	pPrint->PrintLine("");
	pPrint->PrintLine(CString('-',74);
	pPrint->PrintLine("");
	Text.Format("%4s   %06s  %-33s %11s  %11s","Lbnr"," Dato ",
				"Tekst","Belb", "Saldo");
	pPrint->PrintLine(Text);
	pPrint->PrintLine(CString('-',74);
	LinieNr = LinieNr + 9;
}

void	CxKontoUdtogUdskrift::BehandlSubItem	(void)
{
	Saldo = Saldo + KontoTransaktion.GetBeloeb();

	UdskrivSubItem();

	NextSubItem();
}

void	CxKontoUdtogUdskrift::UdskrivSubItem	(void)
{
	CString Text;
	CTime	Dato(KontoTransaktion.GetDato());

	Text.Format("%04ld   %02ld%02ld%02ld  %-33s %11.2f  %11.2f",
				KontoTransaktion.GetLbNr(),
				long(Dato.GetYear()%100),
				Dato.GetMonth(),
				Dato.GetDay(),
				KontoTransaktion.GetTekst(),
				KontoTransaktion.GetBeloeb(),
				Saldo
				);
	pPrint->PrintLine(Text);
	LinieNr = LinieNr + 1;
}

void	CxKontoUdtogUdskrift::FirstMainItem		(void)
{
	Konto.QueryAll();
	// Konto.MoveFirst();
}
BOOL	CxKontoUdtogUdskrift::MoreMainItems		(void)
{	
	return (!Konto.IsEOF());
}
void	CxKontoUdtogUdskrift::NextMainItem		(void)
{
	Konto.MoveNext();
}


void	CxKontoUdtogUdskrift::FirstSubItem		(void)
{
	KontoTransaktion.QueryKontoNr(Konto.GetKontoNr());
	// KontoTransaktion.MoveFirst();
	Saldo = 0;
	SideNr = 0;
}
BOOL	CxKontoUdtogUdskrift::MoreSubItems		(void)
{	
	return (!KontoTransaktion.IsEOF());
}
void	CxKontoUdtogUdskrift::NextSubItem		(void)
{
	KontoTransaktion.MoveNext();
}

// Slut p filen KontoUdtogUdskrift.cpp
